import Flutter
import UIKit
import Combine
import AVFoundation

public class SwiftGetbgmPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "getbgm", binaryMessenger: registrar.messenger())
    let instance = SwiftGetbgmPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
      
      let method = call.method
      let args = call.arguments as? [String: Any]

      switch method {
      case "getPlatformVersion":
           result("iOS " + UIDevice.current.systemVersion)
           break
      case "getBgm":
           guard let videoPath = args?["videoPath"] as! String? else {
                result(nil)
                return
            }
          
          let songID = NSUUID().uuidString
          
          let in_url = URL(fileURLWithPath: videoPath)
          let out_url = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask)[0].appendingPathComponent("\(songID).m4a")
          
          let asset = AVURLAsset(url: in_url)
          asset.writeAudioTrack(to: out_url, success: {
              result(out_url.absoluteString)
//            print("Converted video-mp4 to audio-m4a: \(out_url.absoluteString)")
          }) { (error) in
//            print(error.localizedDescription)
              result(nil)
           }
           
           break
      default:
          result(FlutterMethodNotImplemented)
      }
  }
    

}
